;********** Subrutina en ensamblador: alcance.asm
;   Esta subrutina calcula la matriz de alcanze a partir de la matriz de
; alcanzabilidad. Basta con trasponer esta ltima para lograrlo. Como previamente
; se haban igualado las matrices, se trabaja solo con la matriz de alcance.
; Se reciben dos parmetros: la matriz a trasponer y el nmero de filas (y
; columnas) que tiene.

;  for (i = 0; i < nnodos; i++)
;    for (j = 0; j < nnodos; j++)
;      matrizQ[POS(j,i)] = matrizR[POS(i,j)];

.model small, c  ; Se indica modelo de memoria y el convenio de nombres del C
public Calcula_alcance      ; exportamos el nombre del procedimiento

.data
i dw 0
j dw 0
n dw 0
paso dw 2

.code
Calcula_alcance proc

ARG   su1:PTR,su2:PTR  ; directiva simplificada para acceder a parmetros

PUSH AX
PUSH BX
PUSH CX
PUSH DX
PUSH SI
PUSH DI

MOV BX, su1 	; matriz de alcance
MOV SI, su2
MOV CX, [SI]
MOV n, CX	; n de filas

bucle_i: MOV i, CX
	 DEC i
	 PUSH CX
; el elemento (i,j) est en la posicin  i*n_filas+j
bucle_j: MOV j, CX
	 DEC j

	 MOV AX, i      ; se calcula la posicin  del elemento (i,j)
	 MUL n
	 ADD AX, j
	 MUL paso	; un int son 2 word
	 MOV SI, AX	; se guarda en SI

	 MOV AX, j      ; se calcula la posicin  del elemento (j,i)
	 MUL n
	 ADD AX, i
	 MUL paso	; un entero son 2 word
	 MOV DI, AX	; se guarda en DI

	 MOV AX, [BX][SI] 	; se intercambia el dato de BX+SI a BX+DI
	 MOV DX, [BX][DI]
	 MOV [BX][DI], AX
	 MOV [BX][SI], DX

	 LOOP bucle_j
	 POP CX
	 LOOP bucle_i

POP DI
POP SI
POP DX
POP CX
POP BX
POP AX

ret
endp		; fin del procedimiento

end