;********** Subrutina en ensamblador: alcanza.asm
;   Esta subrutina calcula la matriz de alcanzabilidad. Se reciben dos
; parmetros: la matriz de alcanzabilidad y el nmero de filas (y
; columnas) que tiene.

; while (cambio) {
;   cambio = FALSE;
;   /* recorro toda la matriz */
;   for (i = 0; i < nnodos; i++)
;     for (j = 0; j < nnodos; j++)
;/* si existe camino de i a j se miran los arcos que salen de j y */
;/* se aaden a los de i */
;     	if ((matrizR[POS(i,j)] == 1) && (i != j))
;	  for (k = 0; k < nnodos; k++)
;	    if ((matrizR[POS(j,k)] == 1) && (matrizR[POS(i,k)] != 1)) {
;	      matrizR[POS(i,k)] = 1; /* se aade el camino de i a k */
;            cambio= TRUE;
;	    }
;  }
.model small, c  ; Se indica modelo de memoria y el convenio de nombres del C
public Calcula_alcanza      ; exportamos el nombre del procedimiento

.data
i dw 0
j dw 0
k dw 0
n dw 0
paso dw 2
cambio dw ?

.code
Calcula_alcanza proc

ARG   su1:PTR,su2:PTR  ; directiva simplificada para acceder a parmetros

PUSH AX
PUSH BX
PUSH CX
PUSH DX
PUSH SI
PUSH DI


MOV BX, su1 	; matriz de alcanzabilidad
MOV SI, su2
MOV CX, [SI]
MOV n, CX	; n de filas

MOV AX, 1
MOV cambio, AX			; cambio = TRUE
bucle_w: MOV AX, cambio
	 CMP AX, 1
	 JE cuerpo
	 JMP fin

 cuerpo: XOR AX, AX		; AX = 0
	 MOV cambio, AX		; cambio = FALSE
	 MOV i, AX		; i = 0

bucle_i: XOR AX, AX
	 MOV j, AX		; j = 0

bucle_j: MOV AX, i 		; se calcula la posicin del
	 MUL n			; elemento (i,j)
	 ADD AX, j		; en la matriz
	 MUL paso
	 MOV SI, AX		; posicin en SI

; tenemos que comprobar if ((matrizR[POS(i,j)] == 1) && (i != j))

	 MOV AX, [BX][SI]	; AX = matrizR[i,j]
	 CMP AX, 1              ;  matrizR[i,j] = 1 ?
	 JNE fin1		; si matrizR[i,j] != 1 no se sigue

	 MOV AX, i
	 CMP AX, j		;  i = j ?
	 JE fin1		; si i = j no se sigue

	 XOR AX, AX
	 MOV k, AX		; k = 0
bucle_k: MOV AX, j		; se calcula la posicin
	 MUL n			; del elemento (j,k)
	 ADD AX, k		; dentro de la matriz
	 MUL paso
	 MOV SI, AX		; desplazamiento en SI
	 JMP sigue
bucle_i2: JMP bucle_i

; tenemos que comprobar if ((matrizR[POS(j,k)] == 1) && (matrizR[POS(i,k)] != 1))

  sigue: MOV AX, [BX][SI]	; AX = matrizR[j,k]
	 CMP AX, 1		;  matrizR[POS(j,k)] = 1 ?
	 JNE fin2		; si matrizR[POS(j,k)] != 1 no se sigue

	 MOV AX, i		; se calcula la posicin
	 MUL n			; del elemento (i,k)
	 ADD AX, k		; dentro de la matriz
	 MUL paso
	 MOV DI, AX		; desplazamiento en DI

	 MOV AX, [BX][DI]	; AX = matrizR[i,k]
	 CMP AX, 1		;  matrizR[i,k] = 1 ?
	 JE fin2		; si matrizR[i,k] = 1 no se sigue

	 MOV AX, 1
	 MOV [BX][DI], AX	; matrizR[i,k] = 1
	 MOV cambio, AX		; cambio = TRUE

   fin2: INC k
	 MOV AX, k
	 CMP AX, n
	 JL bucle_k

   fin1: INC j
	 MOV AX, j
	 CMP AX, n
	 JL bucle_j

	 INC i
	 MOV AX, i
	 CMP AX, n
	 JL bucle_i2

	 JMP bucle_w
    fin:

POP DI
POP SI
POP DX
POP CX
POP BX
POP AX

ret
endp		; fin del procedimiento

end