;********** Subrutina en ensamblador: algo2.asm
;   Esta subrutina realiza la segunda parte del algoritmo de Dijkstra. Se
; reciben 6 parmetros: los vectores de distancia, etiquetado y
; predecesores, la matriz de conexin. la matriz de pesos y el n de nodos.

; min = INF;
; for (i = 0; i < mnodos; i++)
;   if ((!etiquetado[i]) && (d[i] < min)) {
;     min = d[i];
;     candidato = i;
;    }
; etiquetado[candidato] = TRUE;*/

.model small, c  ; Se indica modelo de memoria y el convenio de nombres del C
public Algoritmo2    ; exportamos el nombre del procedimiento

.data
i dw 0
n dw 0		; n de nodos
paso dw 2
d dw ?		; direccin de comienzo del vector d
etiq dw ?	; direccin de comienzo del vector etiquetado
pred dw ?	; direccin de comienzo del vector pred
candidato dw ?  ; nodo candidato
min dw ?
p dw ?		; nodo sucesor
mFC dw ?	; direccin de comienzo de la matriz de conexin
mP dw ?		; direccin de comienzo de la matriz de pesos
iter dw ?

.code
Algoritmo2 proc

ARG   su1:PTR,su2:PTR,su3:PTR,su4:PTR,su5:PTR,su6:PTR

PUSH AX
PUSH BX
PUSH CX
PUSH DX
PUSH SI
PUSH DI

MOV SI, su1	; vector d
MOV d, SI

MOV SI, su2	; vector etiq
MOV etiq, SI

MOV SI, su3	; vector pred
MOV pred, SI

MOV SI, su4	; matrizFC
MOV mFC, SI

MOV SI, su5	; matriz de pesos
MOV mP, SI

MOV SI, su6
MOV CX, [SI]
MOV n, CX	; n de nodos

MOV iter, 0
bucle_it: MOV min, 32767
	  MOV i, 0

bucle_i1: MOV AX, i		; se calcula la posicin del
	  MUL paso		; elemento i-simo
	  MOV SI,AX		; SI desplazamiento dentro del vector

	  MOV BX, etiq		; BX como base del vector etiquetado
	  MOV AX, [BX][SI]	; AX = etiquetado[i]
	  CMP AX, 1		; etiquetado[i] = TRUE ?
	  JE fin		; si ha sido etiquetado, no se sigue

	  MOV BX, d		; BX base para vector d
	  MOV AX, [BX][SI]	; AX = d[i]
	  CMP AX, min
	  JGE fin		; si d[i] >= min no se sigue
;en este punto se verifica que !etiquetado[i] && d[i] < min
	  MOV min, AX		; min = d[i]
	  MOV AX, i		; AX = i
	  MOV candidato, AX	; candidato = i

    fin : INC i
	  MOV AX, i
	  CMP AX, n
	  JL bucle_i1

MOV AX, candidato	; se calcula la posicin de
MUL paso		; candidato en el vector
MOV SI, AX
PUSH SI		        ; se almacena para futuras operaciones
MOV BX, etiq		; BX base para etiquetado
MOV AX, 1
MOV [BX][SI], AX	; etiquetado[candidato] = TRUE

; sucesor de candidato
; for (i = 0; (i < mnodos) && (!matrizFC[POS2(candidato,i)]); i++);
; p = i;

MOV i, 0
bucle_i2: MOV AX,i
	  CMP AX, n	; i < mnodos ?
	  JGE fin1	; si i >= mnodos no se sigue

	  MOV AX, candidato	; se calcula la posicin del
	  MUL n			; elemento (candidato,i)
	  ADD AX, i		; en la matriz
	  MUL paso
	  MOV SI, AX		; se guarda el desplazamiento en SI

	  MOV BX, mFC		; BX base de la matriz de conexin
	  MOV AX, [BX][SI]	; AX = matizFC[candidato,i]
	  CMP AX, 1             ; matrizFC[candidato,i] = 1 ?
	  JE fin1		; si matrizFC[candidato,i] = 1 no se sigue
	  INC i
	  LOOP bucle_i2

    fin1: MOV AX, i
	  MOV p, AX             ; p = i

; while (p <= mnodos) {
;   if ((!etiquetado[p])&&(d[p] > d[candidato] + matrizP[POS2(candidato,p)])){
;     d[p] = d[candidato] + matrizP[POS2(candidato,p)];
;     pred[p] = candidato;
;   }
;   p++;
;   for (i = p; (i < mnodos) && (!matrizFC[POS2(candidato,i)]); i++);
;     p = i;
; }


bucle_w: PUSH n
	 PUSH AX
	 MOV AX, n
	 DEC AX
	 MOV n, AX
	 POP AX
	 CMP AX, n	; while p <= mnodos
	 POP n
	 JLE cuerpo
	 JMP fin2

 cuerpo: MOV AX, p		; posicin del nodo p dentro del vector
	 MUL paso
	 MOV SI, AX
	 MOV BX, etiq		; BX base para etiquetado
	 MOV AX, [BX][SI]       ; AX = etiquetado[p]
	 CMP AX, 1
	 JE fin3		; si etiquetado[p] = TRUE no se sigue

	 MOV AX, candidato	; se calcula la posicin del
	 MUL n			; elemento (candidato,p)
	 ADD AX, p		; en la matriz de pesos
	 MUL paso
	 MOV DI, AX		; se guarda el desplazamiento en DI

	 MOV BX, mP		; BX base de la matriz
	 MOV AX, [BX][DI]	; AX = matizP[candidato,p]

	 POP SI			; SI tiene la posicin de candidato
	 PUSH SI
	 MOV BX, d		; BX base para el vector d
	 ADD AX, [BX][SI]	; AX = d[candidato] + matizP[candidato,p]
	 PUSH AX

	 MOV AX, p		; posicin de p dentro del vector
	 MUL paso
	 MOV SI, AX
	 MOV BX, d		; BX base para d
	 MOV DX, [BX][SI]	; DX = d[p]

	 POP AX
	 CMP DX, AX		; d[p] > d[candidato] + matizP[candidato,p]
	 JLE fin3

	 MOV DX, SI		; DX desplazamiento de p
	 POP SI                 ; SI desplazamiento de candidato
	 PUSH SI
	 MOV AX, [BX][SI]	; AX = d[candidato]
	 MOV BX, mP		; BX base para matrizP
	 ADD AX, [BX][DI]	; AX = d[candidato] + matrizP[candidato,p]
	 MOV BX, d		; BX base para d
	 MOV SI, DX		; SI desplazamiento para p
	 MOV [BX][SI], AX	; d[p] = d[candidato] + matrizP[candidato,p]

	 MOV BX, pred		; BX base para pred
	 MOV AX, candidato
	 MOV [BX][SI], AX	; pred[p] = candidato
   fin3: JMP sigue

; sucesor de p
bucle_it2: JMP bucle_it		; el salto es mayor de 127
sigue: INC p
MOV AX, p
MOV i, AX
bucle_i3: MOV AX,i
	  CMP AX, n	; i < mnodos ?
	  JGE fin4	; si i >= mnodos no se sigue

	  MOV AX, candidato	; se calcula la posicin del
	  MUL n			; elemento (candidato,i)
	  ADD AX, i		; en la matriz
	  MUL paso
	  MOV SI, AX		; se guarda el desplazamiento en SI

	  MOV BX, mFC		; BX base de la matriz de conexin
	  MOV AX, [BX][SI]	; AX = matizFC[candidato,i]
	  CMP AX, 1             ; matrizFC[candidato,i] = 1 ?
	  JE fin4		; si matrizFC[candidato,i] = 1 no se sigue
	  INC i
	  LOOP bucle_i3

    fin4: MOV AX, i
	  MOV p, AX             ; p = i

	  JMP bucle_w
    fin2:                       ; fin del bucle while


POP SI				; se deja la pila igual

INC iter
MOV AX, iter
CMP AX, n
JL bucle_it2			; fin del bucle iter

POP DI
POP SI
POP DX
POP CX
POP BX
POP AX

ret
endp		; fin del procedimiento

end