;********** Subrutina en ensamblador: buscar.asm
;   Esta subrutina inicia los nodos pertenecientes a cada componente.
; Se reciben 5 parmetros: la matriz de componentes, el vector de usados,
; la matriz de alcance (que realmete contiene el resultado de la multiplicacin),
; el n de nodos y la variable n de componentes.

; for (i = 0; i < nnodos; i++) {
;   aumento = FALSE;
;   for (j = 0; j < nnodos; j++)
;     if ((matrizQ[POS(i,j)]) && (!usados[j])) {
;	componentes[POS(n_comp,j)] = 1;
;	usados[j] = TRUE;
;	aumento = TRUE;
;     }
;   if (aumento)
;     n_comp++;
; }
.model small, c  ; Se indica modelo de memoria y el convenio de nombres del C
public Buscar    ; exportamos el nombre del procedimiento

.data
i dw ?
j dw ?
n dw ?		; n de nodos
paso dw 2
n_c dw 0
u dw ?		; direccin de comienzo del vector usados
c dw ?		; direccin de comienzo de la matriz componentes
mQ dw ?		; direccin de comienzo de la matriz de alcance
aumento dw 0	; inidica si ha habido un aumento en el n de componentes

.code
Buscar proc

ARG   su1:PTR,su2:PTR,su3:PTR,su4:PTR,su5:PTR

PUSH AX
PUSH BX
PUSH CX
PUSH DX
PUSH SI
PUSH DI


MOV SI, su1	; matriz componentes
MOV c, SI

MOV SI, su2	; vector usados
MOV u, SI

MOV SI, su3	; vector de alcance
MOV mQ, SI

MOV SI, su4
MOV AX, [SI]
MOV n, AX	; n de nodos

MOV SI, su5
MOV AX, [SI]
MOV n_c, AX	; n de componentes

XOR AX, AX
MOV i, AX
bucle_i: XOR AX,AX
	 MOV aumento, AX	; aumento = FALSE
	 MOV j, AX		; j = 0

bucle_j: MOV AX, i		; se calcula la posicin del
	 MUL n			; elemento (i,j)
	 ADD AX, j
	 MUL paso
	 MOV SI,AX		; SI desplazamiento dentro de la matriz

	 MOV BX, mQ		; BX como base de la matrizQ
	 MOV AX, [BX][SI]	; AX = matrizQ[i,j]
	 CMP AX, 1		;  matrizQ[i,j] = 1 ?
	 JNE fin		; si matrizQ[i,j] = 0 no se sigue

	 MOV AX, j		; se calcula la posicin del
	 MUL paso		; elemento j dentro del vector
	 MOV DI, AX             ; se guarda en DI

	 MOV BX, u		; BX base para usados
	 MOV AX, [BX][DI]	; AX = usados[j]
	 CMP AX, 1		;  usados[j] = TRUE ?
	 JE fin			; si ya ha sido usado no se sigue

	 MOV AX, n_c		; se calcula la posicin
	 MUL n			; del elemento (n_comp, j)
	 ADD AX, j		; en la matriz
	 MUL paso
	 MOV SI, AX		; se guarda en SI
	 JMP sigue

bucle_i1:JMP bucle_i
  sigue: MOV BX, c		; BX base para componentes
	 MOV AX, 1
	 MOV [BX][SI], AX	; componentes[n_comp,j] = 1

	 MOV BX, u		; BX base para usados
	 MOV [BX][DI], AX	; usados[j] = TRUE

	 MOV aumento, AX	; aumento = TRUE

    fin: INC j
	 MOV AX, j
	 CMP AX, n
	 JL bucle_j

	 MOV AX, aumento
	 CMP AX, 1		;  aumento = TRUE ?
	 JNE fin1		; si no hay aumento no se sigue
	 INC n_c

   fin1: INC i
	 MOV AX, i
	 CMP AX, n
	 JL bucle_i1

MOV SI, su5
MOV AX, n_c
MOV [SI], AX			; se devuelve el n de componentes en la variable

POP DI
POP SI
POP DX
POP CX
POP BX
POP AX

ret
endp		; fin del procedimiento

end