;********** Subrutina en ensamblador: cal_nod.asm
;   Esta subrutina calcula los nodos pertenecientes a la componente
; fuertemente conexa elegida. Se reciben 4 parmetros: el vector de
; nodos pertenecientes, la matriz de componentes, el nmero de filas y la
; fila de la matriz que contiene la CFC.

; j = 0;
; for (i = 0; i < nnodos; i++)
;   if (componentes[POS(num_CFC,i)]) { /* si el nodo i pertenece a la CFC */
;     nodos_pert[j] = i;
;     j++;
;   }

.model small, c  ; Se indica modelo de memoria y el convenio de nombres del C
public Calcula_nodos      ; exportamos el nombre del procedimiento

.data
i dw 0
j dw 0
n dw 0
paso dw 2
num dw 0


.code
Calcula_nodos proc

ARG   su1:PTR,su2:PTR,su3:PTR,su4:PTR

PUSH AX
PUSH BX
PUSH CX
PUSH DX
PUSH SI
PUSH DI


MOV DI, su1 	; vector nodos_pert
MOV BX, su2	; matriz de componentes
MOV SI, su3
MOV CX, [SI]
MOV n, CX	; n de filas
MOV SI, su4
MOV AX, [SI]
MOV num, AX     ; n de la fila en la matriz de la CFC


bucle_i: MOV AX, num ; se calcula la posicin  del elemento (num,i)
	 MUL n
	 ADD AX, i
	 MUL paso	; un int son 2 word
	 MOV SI, AX	; se guarda en SI

	 MOV AX, [BX][SI] 	; se comprueba si el elemento pertenece
				; a la componente (est a 1)
	 CMP AX, 1
	 JE cuerpo_if
	 JMP fin
cuerpo_if: MOV AX, j		; se calcula la posicin del elemento j
	   MUL paso		; dentro del vector
	   PUSH BX
	   MOV BX, DI           ; BX como base del vector
	   PUSH DI
	   MOV DI, AX		; DI como desplazamiento del vector
	   MOV AX, i            ; el nodo i-simo del grafo es
	   MOV [BX][DI], AX	; el j que pertenece a la CFC
	   POP DI
	   POP BX
	   INC j
	   JMP fin

fin:	 INC i
	 MOV AX, i
	 CMP AX, n
	 JL bucle_i

POP DI
POP SI
POP DX
POP CX
POP BX
POP AX

ret
endp		; fin del procedimiento

end