;********** Subrutina en ensamblador: inicia.asm
;   Esta subrutina inicia el vector de usados a FALSE y la matriz de
; componentes a 0. Se reciben tres parmetros: el vector de usados,
; la matriz de componentes y el n de filas. Para poner a FALSE los
; elementos del vector bastar con ponen un 0 en las celdas. El tipo
; boolean ocupa 2 bytes.

;  for (i = 0; i < nnodos; i++) {
;    usados[i] = FALSE;
;    for (j = 0; j < nnodos; j++)
;      componentes[POS(i,j)] = 0;
;  }

.model small, c  ; Se indica modelo de memoria y el convenio de nombres del C
public Inicia    ; exportamos el nombre del procedimiento

.data
i dw 0
j dw 0
n dw 0
paso dw 2

.code
Inicia proc

ARG   su1:PTR,su2:PTR,su3:PTR  ; directiva simplificada para acceder a parmetros

PUSH AX
PUSH BX
PUSH CX
PUSH DX
PUSH SI
PUSH DI


MOV DI, su1 	; vector usados
MOV BX, su2	; matriz de componentes
MOV SI, su3
MOV CX, [SI]
MOV n, CX	; n de filas

bucle_i: MOV i, CX
	 DEC i

	 MOV AX, i		; se calcula la posicin del
	 MUL paso		; elemento i-simo
	 MOV SI,AX		; SI desplazamiento dentro del vector
	 PUSH BX
	 MOV BX, DI		; BX como base del vector usados
	 XOR AX, AX		; AX = 0
	 MOV [BX][SI], AX       ; se pone a FALSE
	 POP BX

	 PUSH CX
	 MOV CX, n
; el elemento (i,j) est en la posicin  i * n + j
bucle_j: MOV j, CX
	 DEC j

	 MOV AX, i      ; se calcula la posicin  del elemento (i,j)
	 MUL n
	 ADD AX, j
	 MUL paso	; un int son 2 word
	 MOV SI, AX	; se guarda en SI el desplazamiento

	 XOR AX, AX             ; AX = 0
	 MOV [BX][SI], AX	; un 0 en la matriz de componentes

	 LOOP bucle_j
	 POP CX
	 LOOP bucle_i


POP DI
POP SI
POP DX
POP CX
POP BX
POP AX

ret
endp		; fin del procedimiento

end