;********** Subrutina en ensamblador: matrizFC.asm
;   Esta subrutina realiza calcula la nueva matriz de conexin a partir
; de la anterior y de los nodos pertenecientes a la componente fuertemente
; conexa. Recibe 5 parmetros: la nueva matriz, la vieja, el vector de nodos
; pertenecientes, el nuevo n de filas y el viejo n de filas.

;  for (i = 0; i < mnodos; i++)
;    for (j = 0; j < mnodos; j++)
;      matrizFC[POS2(i,j)] = matriz[POS(nodos_pert[i],nodos_pert[j])];

.model small, c  ; Se indica modelo de memoria y el convenio de nombres del C
public Nueva_matriz   ; exportamos el nombre del procedimiento

.data
i dw 0
j dw 0
n dw 0
mn dw 0
paso dw 2
origen dw ?	; direccin de inicio de matriz
destino dw ?	; direccin de inicio de matrizFC
a dw ?		; posicin i dentro de nodos_pert
b dw ?		; posicin j dentro de nodos_pert
; Luego a y b formarn el elemento (a,b) de la matriz vieja

.code
Nueva_matriz proc

ARG   su1:PTR,su2:PTR,su3:PTR,su4:PTR,su5:PTR

PUSH AX
PUSH BX
PUSH CX
PUSH DX
PUSH SI
PUSH DI

MOV DI, su1 	; matrizFC
MOV destino, DI
MOV SI, su2	; matriz de conexin
MOV origen ,SI
MOV BX, su3	; nodos_pert
MOV SI, su4
MOV CX, [SI]
MOV mn, CX	; nuevo n de filas
MOV SI, su5
MOV AX, [SI]
MOV n, AX	; viejo n de filas

bucle_i: MOV i, CX
	 DEC i
	 PUSH CX
	 MOV CX, mn
bucle_j: MOV j, CX
	 DEC j

	 MOV AX, i      ; se calcula la posicin  del elemento (i,j)
	 MUL mn		; para la matrizFC
	 ADD AX, j
	 MUL paso	; un int son 2 word
	 MOV DI, AX	; se guarda en DI

	 MOV AX, i	; se calcula la posicin de i en nodos_pert
	 MUL paso
	 PUSH SI
	 MOV SI, AX

	 MOV AX, j	; se calcula la posicin de j en nodos_pert
	 MUL paso
	 PUSH DI
	 MOV DI, AX

	 MOV AX, [BX][SI]   ; se calcula el elemento (a,b)
	 MOV DX, [BX][DI]
	 MOV a, AX
	 MOV b, DX
	 POP DI
	 POP SI

	 MOV AX, a	 ; se calcula la posicin de (a,b)
	 MUL n
	 ADD AX, b
	 MUL paso
	 MOV SI, AX	; se pone en SI

	 PUSH BX
	 MOV BX, origen
	 MOV AX, [BX][SI] 	; elemento vieja matriz
	 MOV BX, destino	; base para la matrizFC
	 MOV [BX][DI], AX	; matrizFC = matriz
	 POP BX

	 LOOP bucle_j
	 POP CX
	 LOOP bucle_i

POP DI
POP SI
POP DX
POP CX
POP BX
POP AX

ret
endp		; fin del procedimiento

end

