;********** Subrutina en ensamblador: mult.asm
;   Esta subrutina realiza la multiplicacin elemento a elemento de la
; matriz de alcance con la matriz de alcanzabilidad. Se reciben tres parmetros:
; la matriz de alcazabilidad, la matriz de alcance y el n de filas. Vamos a
; usar la matriz de alcance como destino de la multiplicacin.

;  for (i = 0; i < nnodos; i++)
;    for (j = 0; j < nnodos; j++)
;      matrizQ[POS(i,j)] = matrizR[POS(i,j)] * matrizQ[POS(i,j)];

.model small, c  ; Se indica modelo de memoria y el convenio de nombres del C
public Multiplicacion   ; exportamos el nombre del procedimiento

.data
i dw 0
j dw 0
n dw 0
paso dw 2

.code
Multiplicacion proc

ARG   su1:PTR,su2:PTR,su3:PTR  ; directiva simplificada para acceder a parmetros

PUSH AX
PUSH BX
PUSH CX
PUSH DX
PUSH SI
PUSH DI


MOV BX, su1 	; matriz de alcanzabilidad
MOV DI, su2	; matriz de alcance
MOV SI, su3
MOV CX, [SI]
MOV n, CX	; n de filas

bucle_i: MOV i, CX
	 DEC i
	 PUSH CX
	 MOV CX, n
; el elemento (i,j) est en la posicin  i * n + j
bucle_j: MOV j, CX
	 DEC j

	 MOV AX, i      ; se calcula la posicin  del elemento (i,j)
	 MUL n
	 ADD AX, j
	 MUL paso	; un int son 2 word
	 MOV SI, AX	; se guarda en SI

	 MOV AX, [BX][SI] 	; elemento alcanzabilidad
	 PUSH BX
	 MOV BX, DI		; base para la matriz alcance
	 MOV DX, [BX][SI]	; elemento alcance
	 MUL DX			; multiplicacin
	 MOV [BX][SI], AX	; resultado en alcance
	 POP BX

	 LOOP bucle_j
	 POP CX
	 LOOP bucle_i

POP DI
POP SI
POP DX
POP CX
POP BX
POP AX

ret
endp		; fin del procedimiento

end